require "sketchup.rb"
# Main code (start module name with capital letter)

module Afu_sketchup
 def self.insert_af
	model = Sketchup.active_model
	
	af_path = Sketchup.find_support_file "skp"
	af_def = model.definitions.load af_path
	af_location = Geom::Point3d.new 0,0,0
	transform = Geom::Transformation.new af_location
	entities = model.active_entities
	instance = entities.add_instance af_def, transform
	instance.locked = true
	if(model.pages.length==0)
		target = [246,-300,70]
		up = [0,0,1]
		eye_a1 = [105.95, -485.8, 15.75]
		eye_a14 = [381.5, -485.8, 15.75]
		eye_j7 = [243.7, -722.6, 59.25]
		eye_p1 = [72.5, -960.2,114.2]
		eye_p18 = [417.9,-960.2,114.2]
		eye_start = [708.7, -551.2, 320.75]
		
		camera_a1 = Sketchup::Camera.new eye_a1, target, up, true, 50.0
		camera_a14 = Sketchup::Camera.new eye_a14, target, up, true, 50.0
		camera_j7 = Sketchup::Camera.new eye_j7, target, up, true, 50.0
		camera_p1 = Sketchup::Camera.new eye_p1, target, up, true, 50.0
		camera_p18 = Sketchup::Camera.new eye_p18, target, up, true, 50.0
		camera_start = Sketchup::Camera.new eye_start, [0,0,-200], up, true, 50.0
		
		model.active_view.camera = camera_a1
		a1 = model.pages.add("A1",1)
		a1.transition_time = 0.5
		
		model.active_view.camera = camera_a14
		a14 = model.pages.add("A14",1)
		a14.transition_time = 0.5
		
		model.active_view.camera = camera_j7
		j7 = model.pages.add("J7",1)
		j7.transition_time = 0.5
		
		model.active_view.camera = camera_p1
		p1 = model.pages.add("P1",1)
		p1.transition_time = 0.5
		
		model.active_view.camera = camera_p18
		p18 = model.pages.add("P18",1)
		p18.transition_time = 0.5
		
		model.active_view.camera = camera_start
	end

end

	
	def self.rotate_90_r
	model = Sketchup.active_model
	xt = 0
	yt = 0
	zt = 0
	model.selection.each{	|entity| 
							xt = xt + entity.bounds.center.x
							yt = yt + entity.bounds.center.y
							zt = zt + entity.bounds.center.z
						}
	number = model.selection.count
	xt = xt/number
	yt = yt/number
	zt = zt/number
	transformation = Geom::Transformation.rotation [xt,yt,zt], [1,0,0], 90.degrees
	Sketchup.active_model.active_entities.transform_entities(transformation,Sketchup.active_model.selection)
	end
	
	def self.rotate_90_g
	model = Sketchup.active_model
	xt = 0
	yt = 0
	zt = 0
	model.selection.each{	|entity| 
							xt = xt + entity.bounds.center.x
							yt = yt + entity.bounds.center.y
							zt = zt + entity.bounds.center.z
						}
	number = model.selection.count
	xt = xt/number
	yt = yt/number
	zt = zt/number
	transformation = Geom::Transformation.rotation [xt,yt,zt], [0,1,0], 90.degrees
	Sketchup.active_model.active_entities.transform_entities(transformation,Sketchup.active_model.selection)
	end
	
	def self.rotate_90_b
	model = Sketchup.active_model
	xt = 0
	yt = 0
	zt = 0
	model.selection.each{	|entity| 
							xt = xt + entity.bounds.center.x
							yt = yt + entity.bounds.center.y
							zt = zt + entity.bounds.center.z
						}
	number = model.selection.count
	xt = xt/number
	yt = yt/number
	zt = zt/number
	transformation = Geom::Transformation.rotation [xt,yt,zt], [0,0,1], 90.degrees
	Sketchup.active_model.active_entities.transform_entities(transformation,Sketchup.active_model.selection)
	end
	
end

##########################################################


 AUTHOR      = "Julia Christina Eneroth"
  CONTACT     = "#{AUTHOR} at eneroth3@gmail.com"
  COPYRIGHT   = "#{AUTHOR} #{Time.now.year}"
  DESCRIPTION =
    "Removes all dimensions in current drawing context and its contained "\
    "groups and components similarly to native Edit > Delete Guides."
  AID          =  File.basename __FILE__, ".rb"
  NAME        = "Eneroth Dimension Remover"
  VERSION     = "1.0.0"
  
  REQUIRED_SU_VERSION = "15"

  PLUGIN_ROOT = File.expand_path(File.dirname(__FILE__))

  APLUGIN_DIR = File.join(PLUGIN_ROOT, AID)

##########################################################
 unless Sketchup.version.to_i >= REQUIRED_SU_VERSION.to_i
    msg = "#{NAME} requires Sketchup version 20#{REQUIRED_SU_VERSION} or later to run."
    UI.messagebox(msg)
    raise(msg)
  end

  def self.iterate_entities(entities)
  
    entities.each do |e|
      if [Sketchup::Group, Sketchup::ComponentInstance].include?(e.class)
        self.iterate_entities(e.definition.entities)
      elsif e.is_a?(Sketchup::Dimension)
         e.erase!
      end
    end
    
    nil
  
  end

  def self.remove_dimensions
  
    model = Sketchup.active_model
    model.start_operation "Delete Dimensions"
    self.iterate_entities(model.active_entities)
    model.commit_operation
    
    nil

  end

#########################################################

unless file_loaded?(__FILE__)
 mymenu = UI.menu("Plugins").add_submenu("TC-围轴旋转")

 mymenu.add_item("围轴旋转90 红轴-X") {Afu_sketchup::rotate_90_r}
 mymenu.add_item("围轴旋转90 绿轴-Y") {Afu_sketchup::rotate_90_g}
 mymenu.add_item("围轴旋转90 蓝轴-Z") {Afu_sketchup::rotate_90_b}
 #mymenu.add_item("清除全局标注尺寸") { self.remove_dimensions }
 
  toolbar = UI::Toolbar.new "TC-围轴旋转1.2.2"
   
	 rotate_90_r = UI::Command.new("rotate_r") {
       Afu_sketchup::rotate_90_r
     }
     rotate_90_r.small_icon = "images/rotate_r_l.png"
     rotate_90_r.large_icon = "images/rotate_r_l.png"
     rotate_90_r.tooltip = "围轴旋转 90 红轴"
     rotate_90_r.status_bar_text = "围轴旋转 90 红轴"
     rotate_90_r.menu_text = "围轴旋转 90 红轴"
	 
	 rotate_90_g = UI::Command.new("rotate_g") {
       Afu_sketchup::rotate_90_g
     }
     rotate_90_g.small_icon = "images/rotate_g_l.png"
     rotate_90_g.large_icon = "images/rotate_g_l.png"
     rotate_90_g.tooltip = "围轴旋转 90 绿轴"
     rotate_90_g.status_bar_text = "围轴旋转 90 绿轴"
     rotate_90_g.menu_text = "围轴旋转 90 绿轴"
	 
	 rotate_90_b = UI::Command.new("rotate_b") {
       Afu_sketchup::rotate_90_b
     }
     rotate_90_b.small_icon = "images/rotate_b_l.png"
     rotate_90_b.large_icon = "images/rotate_b_l.png"
     rotate_90_b.tooltip = "围轴旋转 90 蓝轴"
     rotate_90_b.status_bar_text = "围轴旋转 90 蓝轴"
     rotate_90_b.menu_text = "围轴旋转 90 蓝轴"
	
	
	############################################################################
	
	#rotate_90_a = UI::Command.new("rotate_b") { self.remove_dimensions }
     
    # rotate_90_a.small_icon = "images/easyicon.png"
    # rotate_90_a.large_icon = "images/easyicon.png"
    # rotate_90_a.tooltip = "清除全局标注尺寸"
     #rotate_90_a.status_bar_text = "清除全局标注尺寸"
     #rotate_90_a.menu_text = "清除全局标注尺寸"
	
	
	#######################################################
	 toolbar = toolbar.add_item rotate_90_r
	 toolbar = toolbar.add_item rotate_90_g
	 toolbar = toolbar.add_item rotate_90_b
	# toolbar.add_separator
	 #toolbar = toolbar.add_item rotate_90_a
     toolbar.show
 file_loaded(__FILE__)
end